/***
 * Fractal ADL Parser
 * Copyright (C) 2002-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Eric.Bruneton@rd.francetelecom.com
 *
 * Author: Ali Erdem Ozcan
 */

package org.objectweb.fractal.adl;

import java.util.List;
import java.util.Map;

import org.objectweb.fractal.adl.components.ComponentContainer;

/**
 * A visitor dispatcher for {@link ComponentContainer} node.
 * 
 * @see VisitorDispatcher
 */
public class ComponentVisitorDispatcher
    extends
      VisitorDispatcher<ComponentContainer> implements ComponentVisitor {

  @Override
  protected Visitor<ComponentContainer> castVisitorInterface(
      final Object serverItf) {
    return (ComponentVisitor) serverItf;
  }

  @Override
  protected Object[] getCompositionParameters(final List<Node> path,
      final ComponentContainer node, final Map<Object, Object> context) {
    return toArray(node);
  }
}
